
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

AMMOUNT_OF_TAGS equ 5

;------------------------------------------------------------------------------
;This function will send the content of a directory through a html-page
;input:
;    1:psess
;    2:sess
;    3:path
;    4:URL

;output:
;    none
;------------------------------------------------------------------------------
SendDirectoryContent:
call denter
sub pesp,1072+0x10+0x60 ;size of the structure returned by startDirectoryEnumeration and nextDirectoryEnumeration + temp string for the size (0x10 bytes) + 0x60 bytes for the Last modified string
mov pebx,pesp
call createTagsListOnStack

mov pedi,directoryListeningPage

loopSendDirectoryContent:
mov peax,pdword [pebp+psize*5] ;URL
mov pdword [pesp],peax ;set value for tag 01

xor eax,eax
mov pdword [pesp+psize],peax ;zero tag 2
mov pdword [pesp+psize*2],peax ;zero tag 3

  push pesp                  ;tag list
  push 0x02                  ;stop at tag 2
  push pedi                  ;pointer to parsed string
  push pdword [pebp+psize*3] ;lsess
  push pdword [pebp+psize*2] ;psess
  call ParseAndSendByList

  mov pedi,pdword [pesp-3*psize] ;restore pointer to parsed string
  cmp byte[pedi],0
  jz endSendDirectoryContent  ;end if this is the end of the string

  cmp byte [pedi],2
  jne nextSendDirectoryContent

    lea peax,pdword [pebx+4+(7*2)+4+8] ;Filename
    mov pdword [pesp],peax ;set value for tag 01

    lea peax,pdword [pebx+1072] ;string with size
    mov word [peax],'-' ;no size for directories
    mov pdword [pesp+psize],peax ;set value for tag 02

    lea peax,pdword [pebx+1072+0x10] ;string with last modified string
    mov pdword [pesp+psize*2],peax ;set value for tag 03

    ;send content of a directory (start enumerating directories)
    push pebx                  ;return structure
    push pdword [pebp+psize*4] ;path
    call startDirectoryEnumeration
    mov pedx,peax ;(R/E)DX => HANDLE of a directory enumeration
    test peax,peax
    jz nextSendDirectoryContent ;no files

    loopThroughDirectory:
      test dword [pebx],0x10 ;(0x10 = directory)
      jz nextLoopThroughDirectory

      cmp word [pebx+4+(7*2)+4+8],'.'
      je nextLoopThroughDirectory

      ;if the directory is '\' or '/', don't show '..', since it is unable to reach
      mov peax,pdword [pebp+psize*5] ;URL

      cmp word [peax],'/'
      je pathHasNoParent

      cmp word [peax],'\'
      jne pathHasParent

    pathHasNoParent:

      cmp word [pebx+4+(7*2)+4+8],'..'
      jne pathHasParent
      cmp byte [pebx+4+(7*2)+4+8+2],0
      je nextLoopThroughDirectory

    pathHasParent:
      lea peax,pdword [pebx+1072+0x10]
      push peax ;buffer
      lea peax,pdword [pebx+4] ;TIMEDATE structure
      push peax
      call SystemTimeToString

      push pesp                  ;tag list
      push 0                     ;no stop or start tag
      ppush directoryListeningRow ;pointer to parsed string
      push pdword [pebp+psize*3] ;lsess
      push pdword [pebp+psize*2] ;psess
      call ParseAndSendByList

    nextLoopThroughDirectory:
      push pebx ;return structur
      push pedx ;handle
      call nextDirectoryEnumeration
      test peax,peax
    jnz loopThroughDirectory

    push pedx
    call closeDirectoryEnumeration

    ;send content of a directory (start enumerating directories)
    push pebx                  ;return structure
    push pdword [pebp+psize*4] ;path
    call startDirectoryEnumeration
    mov pedx,peax ;(R/E)DX => HANDLE of a directory enumeration
    test peax,peax
    jz nextSendDirectoryContent ;no files

    loopThroughFiles:
      test dword [pebx],0x10 ;(0x10 = directory)
      jnz nextLoopThroughFiles

      lea peax,pdword [pebx+1072+0x10]
      push peax ;buffer
      lea peax,pdword [pebx+4] ;TIMEDATE structure
      push peax
      call SystemTimeToString

      lea peax,pdword [pebx+1072] ;string with size
      push peax ;buffer
      if used is32
        lea peax,pdword [pebx+4+(7*2)+4] ;Filesize
        push eax
      else
        push pdword [pebx+4+(7*2)+4] ;Filesize
      end if
      call convertBytesToString

      push pesp                  ;tag list
      push 0                     ;no stop or start tag
      ppush directoryListeningRow ;pointer to parsed string
      push pdword [pebp+psize*3] ;lsess
      push pdword [pebp+psize*2] ;psess
      call ParseAndSendByList

    nextLoopThroughFiles:
      push pebx ;return structur
      push pedx ;handle
      call nextDirectoryEnumeration
      test peax,peax
    jnz loopThroughFiles

    push pedx
    call closeDirectoryEnumeration


nextSendDirectoryContent:
  inc pedi ;skip the tag index
  cmp byte[pedi],0
jne loopSendDirectoryContent

endSendDirectoryContent:
call sendLastChunk

call dleave
ret psize*4

;------------------------------------------------------------------------------
;This function will create a list of tags (all zero bytes) on stack
;input:
;    none
;output:
;    *R/E)SP => pointer to tags list  (and a string for inttostr on (R/E)SP + (AMMOUNT_OF_TAGS*psize) and one of (R/E)SP + (AMMOUNT_OF_TAGS*psize) + 24)
;corupts:
;       (R/E)AX,(R/E)DX,(R/E)CX, (R/E)DI
;------------------------------------------------------------------------------
createTagsListOnStack:
pop pedx

sub pesp,(AMMOUNT_OF_TAGS*psize) ;create an array with pointer to replace tags with  and five temp strings

;zero structure with pointers for tags
mov ecx,AMMOUNT_OF_TAGS
mov pedi,pesp
xor eax,eax
rep stosp

jmp pedx

;------------------------------------------------------------------------------
;This function will send the page and replace the th bytes (starting with byte '1') while sending
;input:
;    1:psess
;    2:lsess
;    3:pointer to parsed string (on stack return: last position of parsed string)
;    4:stop at tag[8bits):stop at tag[8bits):stop at tag[8bits):start sending from tag(8 bits)
;    5:tags list
;output:
;    none
;------------------------------------------------------------------------------
ParseAndSendByList:
call denter

mov pedi,pdword [pebp+psize*4] ;(R/E)DI => pointer to parsed string
mov pebx,pdword [pebp+psize*6] ;(R/E)BX => list with tags replacements
mov pesi,pedi                  ;backup of parsed page
push pedi
call strlen
mov pecx,peax ;(R/E)CX = size of parsed string
mov pedx,pecx ;(R/E)DX = backup of size

loopParsedString:
  mov al,1 ;1=tag byte
  repnz scasb ;search for tag byte
  jnz sendLastPartOfString

  sub pedx,pecx ;send scaned size
  dec pedx ;decrement the found '1' byte

  mov al,byte [pebp+(psize*5)+3] ;start tag
  test al,al
  jz NoStartTag ;continue processing string since there is not start tag

    cmp al,byte [pedi] ;should we ignore all data before this tag?
    jne nextLoopParsedString ;skip this tag

    mov pdword [pebp+(psize*5)+3],0  ;delete start tag
    jmp nextLoopParsedString

NoStartTag:
  test pedx,pedx
  jz noDataToSendBeforeTag
    call shortSendDataEDXWithChunk ;send ESI with size EDX
    jnz endParseAndSendByList ;jump if lost connection
  noDataToSendBeforeTag:

  xor eax,eax
  mov al,byte [pedi] ;get indicator of the tag we need to replace
  cmp al,AMMOUNT_OF_TAGS
  ja nextLoopParsedString ;jump if this is an invalid tag

  cmp al,byte [pebp+psize*5] ;should we stop processing
  je endParseAndSendByList ;stop processing string at this tag

  cmp al,byte [pebp+(psize*5)+1] ;should we stop processing
  je endParseAndSendByList ;stop processing string at this tag

  cmp al,byte [pebp+(psize*5)+2] ;should we stop processing
  je endParseAndSendByList ;stop processing string at this tag

  dec al ;item 1 is index 0, so -1
  mov peax,[pebx+(psize*peax)] ;get pointer to the tag replacement
  test peax,peax
  jz nextLoopParsedString ;jump, there is no replacement

  call shortSendStringWithChunk ;send string (R/E)AX

nextLoopParsedString:
  ;skip the indicator of the tag
  inc pedi
  sub pecx,1

  mov pesi,pedi ;EDI = copy ESI
  mov pedx,pecx ;ECX = copy EDX
jc endParseAndSendByList
jnz loopParsedString

jmp endParseAndSendByList

sendLastPartOfString:
  sub pedx,pecx ;send scaned size
  jz endParseAndSendByList

  call shortSendDataEDXWithChunk ;send ESI with size EDX

endParseAndSendByList:
mov pdword [pebp+psize*4],pedi
call dleave
ret psize*5

directoryListeningPage db '<!DOCTYPE HTML>',0x0D,0x0A,'<html><head>',0x0D,0x0A,'<meta charset="UTF-8">',0x0D,0x0A,'<meta name="viewport" content="width=device-width, initial-scale=1.0, maximum-scale=1">',0x0D,0x0A,'<style>',0x0D,0x0A,'@media only screen and (max-width:500px) {',0x0D,0x0A,'  table tr td:nth-child(3), table tr td:nth-child(2) { display: none;}',0x0D,0x0A,'  table tr th:nth-child(3), table tr th:nth-child(2) { display: none;}',0x0D,0x0A,'}',0x0D,0x0A,'@media only screen and (max-width:800px) {',0x0D,0x0A,'  a { padding-top: 10px; padding-bottom: 10px; }',0x0D,0x0A,'}',0x0D,0x0A,'</style>',0x0D,0x0A, "<title>",01,01,"</title></head>",0x0D,0x0A,"<body>",0x0D,0x0A,"<h1>Index of ",01,01,"</h1>",0x0D,0x0A,"<table cellSpacing=",0x22,"1",0x22," cellPadding=",0x22,"1",0x22," border=",0x22,"0",0x22,">",0x0D,0x0A,"<TR><TD>FileName</TD><TD>Size</TD><TD>Last Modified</TD></TR>",1,2,"</table>",0x0D,0x0A,"<HR>",0x0D,0x0A,"<ADDRESS>",HtmlAddressNotation,"</ADDRESS>",0x0D,0x0A,"</body></html>",0
endDirectoryListeningPage:

directoryListeningRow db '<TR><TD><a href="',01,01,'">',01,01,"</a></TD><TD>",01,02,"</TD><TD>",01,03,"</TD></TR>",0