
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;Uncomment the line below if you want the log messages in this DLL to be compiled with the file. Thses messages will be logged if switch -l is used.
;CompileLogMessage

PLUGIN_VERSION equ ProductVersionPrefix, ".", FileVersion

CPO_NAME_AUTHOR equ -1
CPO_NAME_VERSION equ -2

include 'include/function.inc'
include 'include/flags.inc'
include 'include/collection.inc'
include 'include_plugin_general/short_functions.inc'
include 'include/stringFunctions.inc'
include 'include_tvs_server_plugin_limit_connections/plugin_handle_connection.inc'

sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols

include 'include_tvs_server_plugin_limit_connections/plugin_bind.inc'
include 'include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'

mymod pointer ?

;------------------------------------------------------------------------------
;Main
;------------------------------------------------------------------------------
main:
StartProc 3
call denter

  cmp dword [pebp+psize*3],1 ;DLL_PROCESS_ATTACH
  jne dontInitDLL

    call initGetSmallestPortionPageAllocation

    if used is32
      call doSystemCheckDLL
    end if

    mov peax,pdword [pebp+psize*2] ;get HMODULE
    mov [mymod],peax

dontInitDLL:
  xor eax,eax
  inc eax

endMain:
EndProc 3
call dleave
ret (FunctionReturnFactor*3)

;------------------------------------------------------------------------------
;The StartProtocol function need to initiate the protocol named in the ProtocolSession structure.
;------------------------------------------------------------------------------
StartProtocol:
StartProc 1
call denter

call initGetSmallestPortionPageAllocation

;Get the protocolName member from ProtocolSession
mov peax,pdword [pebp+(psize*2)]
mov peax,pdword[peax+(psize*1)]

;Do we init manipulator?
if used isLinux
  lea pecx,dword [manipulator]
  push pecx
else
  ppush TVS_SOFTWARE_LIMIT_CONNECTIONS
end if
push peax
call strcmp
test eax,eax
jnz endStartProtocol

;init manipulator
push V_TV_SERVER_102 ;version
push 4 ;extraSize
push 0 ;pSign
push PT_MANIPULATOR  ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

ppush httpControlPanelOptions  ;cpo
push pdword [pebp+(psize*2)] ;psess
call [SetControlPanelOptions]

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_limit_connections],pecx
jmp endStartProtocol

;return
endStartProtocol:
call dleave
EndProc 1
ret (FunctionReturnFactor*1)