
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will start listening
;------------------------------------------------------------------------------
StartListening:
StartProc 3 ;Set arguments on stack

;rerun:
call denter

xor eax,eax ;return value

;check if the psess value is TCP
mov pecx,pdword [pebp+(psize*2)] ;psess
cmp [psess_TCP],pecx
jne endStartListening

;find the data member of this protocol
mov pecx,pdword [pebp+psize*4]  ;Clientsess

mov peax,pdword [pecx+8]

push pdword [pecx+8]          ;ProtocolData structure
push pdword [pebp+psize*2]    ;psess
call [FindProtocolDataStruct]
mov pebx,peax                 ; Data struct of ClientSession

;find the data member of this protocol
mov pecx,pdword [pebp+psize*3]  ;lsess

push pdword [pecx+8]       ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]
mov peax,pdword [peax+psize*2]

;get pointer to sockaddr_in  (for remote address)
mov pecx,pebx
add pecx,psize*4

;get pointer to sockaddr_in  (for local address)
mov pesi,pecx
add pesi,psize+0x20

push pdword [pebx+psize*3] ;addrlen
push pecx                  ;sockaddr (remote address)
push peax                  ;SOCKET
call Accept
mov pdword [pebx+psize*2],peax ;save new socket in ClientSession

push pdword [pebx+psize*3] ;addrlen
push pesi                  ;sockaddr (local address)
push peax                  ;SOCKET
call GetLocalAddress

;check if SOCKET == -1
inc eax
test eax,eax
jz endStartListening

;return 1
xor eax,eax
inc eax

endStartListening:
call dleave
;jmp rerun
EndProc 3
ret (FunctionReturnFactor*3)

;------------------------------------------------------------------------------
;This function will close the listen socket
;------------------------------------------------------------------------------
PrepareCloseListenSession_TCP:
StartProc 2 ;Set arguments on stack
call denter

mov pecx,pdword [pebp+psize*3]  ;lsess

logmod LOG_MESSAGE,pdword [pebp+(psize*2)],pecx,0,0,"Closing down listening socket..."

;find the data member of this protocol
push pdword [pecx+8]       ;ProtocolData structure
push pdword [pebp+psize*2] ;psess
call [FindProtocolDataStruct]

push pdword [peax+psize*2]
call CloseSocket

call dleave
EndProc 2
ret (FunctionReturnFactor*2)

;------------------------------------------------------------------------------
;This function will remove every created recourse created during BindToProtocolCallBack
;------------------------------------------------------------------------------
CloseListenSession_TCP:
StartProc 2 ;Set arguments on stack
call denter

;Nothing to do, nothing allocated (the socket is already closed by PrepareCloseListenSession_TCP

call dleave
EndProc 2
ret (FunctionReturnFactor*2)