
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;Uncomment the line below if you want the log messages in this DLL to be compiled with the file. Thses messages will be logged if switch -l is used.
CompileLogMessage

PLUGIN_VERSION equ ProductVersionPrefix, ".", FileVersion
EXTRASIZE_FLAG_STOP_SESSION equ 0x1

;We want 1 pointers in the Listen/Client session + sizeof(sockadr_in) and a sockaddr_in structure (remote addr) + sizeof(sockadr_in) and a sockaddr_in structure (local addr) + close event + flags
EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP equ psize*2 + 0x20 + psize + 0x20 + psize + psize
EXTRASIZE_SOCKET equ 0
EXTRASIZE_EVENT equ psize*2 + 0x20 + psize + 0x20
EXTRASIZE_FLAGS equ psize*2 + 0x20 + psize + 0x20 + psize

option_port equ 3 ;integer instead of a name (option_1)
option_keepalive_time equ 2 ;integer instead of a name
option_keepalive_interval equ 1 ;integer instead of a name
option_keepalive equ 4 ;integer instead of a name
option_v6 equ 6   ;integer instead of a name (option_3)
option_author equ -1
option_version equ -2

include 'include/function.inc'
include 'include/flags.inc'
include 'include/sockets.inc'
include 'include/math.inc'
include 'include/collection.inc'
include 'include_plugin_general/short_functions.inc'
include 'include/stringFunctions.inc'
include 'include_tvs_server_plugin_tcp_protocol/plugin_handle_connection.inc'



sizeSubportedProtocols equ endSubportedProtocols - subportedProtocols




include 'include_tvs_server_plugin_tcp_protocol/plugin_bind.inc'
include 'include_tvs_server_plugin_tcp_protocol/plugin_listen.inc'
;------------------------------
;-----GetProtocolNames---------
;-----__asm_exchange_tables----
;------------------------------
include 'include_plugin_general/__asm_exchange_tables_GetProtocolNames.inc'

mymod pointer ?


main:
_init:
if used isWin
StartProc 3
end if
call denter

  if used isWin
    cmp dword [pebp+psize*3],1 ;DLL_PROCESS_ATTACH
    jne dontInitDLL
  end if

    call initGetSmallestPortionPageAllocation

    if used is32 & used isWin
      call doSystemCheckDLL
    end if

    if used isWin
      mov peax,pdword [pebp+psize*2] ;get HMODULE
      mov [mymod],peax
    else
      pmov [mymod],_init
    end if



dontInitDLL:
  xor eax,eax
  inc eax

endMain:
call dleave
if used isWin
  EndProc 3
end if
ret (FunctionReturnFactor*3)

;------------------------------------------------------------------------------
;The StartProtocol function need to initiate the protocol named in the ProtocolSession structure.
;------------------------------------------------------------------------------
StartProtocol:
StartProc 1
call denter

;Get the protocolName member from ProtocolSession
mov peax,pdword [pebp+(psize*2)] ;ProtocolSession
logmod LOG_MESSAGE,peax,0,0,0,"Loading protocol..."
mov peax,pdword[peax+(psize*1)] ;protocolName

;Do we init TCP/IP?
ppush tcpip
push peax
call strcmp
test eax,eax
jnz endStartProtocol

push V_TV_SERVER_102 ;version of protocol with TV's server (version 102 supports logging)
push EXTRASIZE_LISTEN_AND_CLIENT_STRUCT_TCP ;extraSize
push 0 ;pSign
push PT_RECEIVER ;type
push pdword [pebp+(psize*2)] ;psess
call [SetProtocolInformation]
test peax,peax
jz endStartProtocol

ppush httpControlPanelOptions  ;cpo
push pdword [pebp+(psize*2)] ;psess
call [SetControlPanelOptions]

;initialize the SOCKET stack on the program
call initilize_socket_api
test eax,eax
jz endStartProtocol

push pdword [pebp+(psize*2)] ;psess
call [AcceptProtocol]

mov pecx,pdword [pebp+(psize*2)] ;psess
mov [psess_TCP],pecx

logmod LOG_MESSAGE,pdword [pebp+(psize*2)],0,0,0,"Protocol succesfully loaded..."

;return
endStartProtocol:
call dleave
EndProc 1
ret (FunctionReturnFactor*1)