
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;------------------------------------------------------------------------------
;This function will fill the buffer with user readable current GMT time and date (format orig-date in RFC 822)
;input:
;    1:Buffer
;output:
;    none
;corupted:
;    EAX
;------------------------------------------------------------------------------
if used GetGMTTime
GetGMTTime:
call denter

push 0
push 0
mov pedi,pesp

if used is64
  argpushsys 2,0
  argpushsys 1,pedi
else
  argpushsys 2,pesp
  argpushsys 1,0 ;CLOCK_REALTIME
end if
linuxCall 96,403 ;gettimeofday / clock_gettime64 `
if used is32
  test peax,peax
  jnl gettimeofday64IsSupported

    argpushsys 2,0
    argpushsys 1,pedi
    linuxCall 0,78 ;gettimeofday
    mov dword [esp+4],0

  gettimeofday64IsSupported:
end if        

if used is64
  pop rdi ;R/EDI => seconds since 1970
  add pesp,psize
end if

sub pesp,0x10 ;create space on stack for DateTime structure

push pesp ;DateTime structure
push pedi ;seconds since 1970
if used RecoverDateTime_asm
  call RecoverDateTime_asm
else
  call [RecoverDateTime]
end if

mov peax,pesp

push pdword [pebp+psize*2] ;buffer
push peax                  ;DateTime structure
call SystemTimeToString

call dleave
ret psize
end if

