
;TV's server version 3.20
;Copyright (c) 2014 - 2022, Tycho Veltmeijer.
;All rights reserved.

;Returns zero on error.
if used loadmodule
   loadmodule:
   call denter
   MakeStack

   if used is32
     cmp [is9x],0
     je useWLoadLibrary

     argpush 1,pdword [pebp+(psize*2)]
     call [LoadLibraryA]
     jmp endLoadmodule

   useWLoadLibrary:
   end if
   push 0
   push pdword [pebp+(psize*2)]
   push 0x11
   call CreateOneString
   mov pdword [pebp+(psize*2)],peax

   argpush 1,pdword [pebp+(psize*2)]
   call [LoadLibraryW]

   push peax

   push pdword [pebp+(psize*2)]
   call FreeMemLocation

   pop peax

   endLoadmodule:
   call dleave
   ret (psize*1)
end if

;------------

;Returns zero on error.
if used loadmoduleA & used is32
   loadmoduleA:
   call denter

   argpush 1,pdword [pebp+(psize*2)]
   call [LoadLibraryA]

   call dleave
   ret (psize*1)
end if

;------------

if used unloadmodule
   unloadmodule:
   call denter
   MakeStack

   argpush 1,pdword [pebp+(psize*2)]
   call [UnLoadLibrary]

   call dleave
   ret (psize*1)
end if

;------------

if used getfunc
   getfunc:
   call denter
   MakeStack

   argpush 2,pdword [pebp+(psize*3)]
   argpush 1,pdword [pebp+(psize*2)]
   call [GetProcAddress]

   call dleave
    ret (psize*2)
end if

;------------------------------------------------------------------------------
;This function frees the pointer returned by GetModuleName
;input:
;    1:pointer returned by getModuleName


;output:
;       none
;------------------------------------------------------------------------------
if used FreeModuleName
  FreeModuleName:

  if used is32
    cmp [is9x],0
    je dontFreePebPointer

      push pdword [pesp+psize]
      call FreeMemLocation

    dontFreePebPointer:
  end if
  ret psize
end if
;------------------------------------------------------------------------------
;This function returns a pointer (possibly allocated by GetMemLocation) with the directory and filename
;Use FreeModuleName to free the pointer
;input:
;    1:modhandle


;output:
;       Pointer with directory and filename or zero
;------------------------------------------------------------------------------
if used GetModuleName
  GetModuleName:
  call denter

if used is32
  cmp [is9x],0
  je usePeb

  push 256
  call GetMemLocation
  push peax ;push for FreeMeMLocation
  push 0    ;push for CreateOneString
  push peax ;push for CreateOneString
  push 0x1 ;ASCII string (push for CreateOneString)

  push 255
  push peax
  push pdword [pebp+(psize*2)] ;HMOD
  call callGetModuleFileNameA

  call CreateOneString
  xchg peax,pdword [pesp]
  push peax

  call FreeMemLocation

  pop peax
  jmp endgetModuleName

  usePeb:
end if

  if used is64
    mov rax, qword [GS:0x60] ;PEB from TEB
  else
    mov eax, dword [fs:0x30] ;PEB from TEB
  end if
  mov peax, pdword [peax+3*psize]   ;PPEB_LDR_DATA
  mov peax, pdword [peax+8+psize*5] ;LDR_MODULE (NTDLL.DLL)
  mov pedx,peax ;Save first module

  findModule:
    mov pecx,pdword [peax+psize*2]  ;BaseAddress
    cmp pdword [pebp+(psize*2)],pecx
    je moduleFound

    mov peax,pdword [peax] ;Next module
    cmp peax,pedx ;Is first module again?
  jne findModule

  xor eax,eax
  jmp endgetModuleName

  moduleFound:
    mov peax, pdword [peax+psize*6]

  endgetModuleName:
  call dleave
  ret psize
end if

;------------

if used callGetModuleFileNameA
;redirect a call to GetModuleFileName in 32bit, create a stack with arguments in 64 first.
if used is32
  callGetModuleFileNameA:
  jmp [GetModuleFileNameA]
else
  callGetModuleFileName:
  call denter
  MakeStack

  argpush 3,pdword [pebp+psize*4]
  argpush 2,pdword [pebp+psize*3]
  argpush 1,pdword [pebp+psize*2]
  call [GetModuleFileNameA]

  call dleave
  ret psize*3
end if
end if